import type { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent, PromiseOrValue } from "../common";
export interface TreasuryInterface extends utils.Interface {
    functions: {
        "getProposalNonce()": FunctionFragment;
        "proposalNonce()": FunctionFragment;
        "rescueTokens(address,address,uint256,uint32)": FunctionFragment;
        "setHandler(address,uint32)": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "getProposalNonce" | "proposalNonce" | "rescueTokens" | "setHandler"): FunctionFragment;
    encodeFunctionData(functionFragment: "getProposalNonce", values?: undefined): string;
    encodeFunctionData(functionFragment: "proposalNonce", values?: undefined): string;
    encodeFunctionData(functionFragment: "rescueTokens", values: [
        PromiseOrValue<string>,
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BigNumberish>
    ]): string;
    encodeFunctionData(functionFragment: "setHandler", values: [PromiseOrValue<string>, PromiseOrValue<BigNumberish>]): string;
    decodeFunctionResult(functionFragment: "getProposalNonce", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "proposalNonce", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "rescueTokens", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setHandler", data: BytesLike): Result;
    events: {
        "TreasuryHandlerUpdated(address)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "TreasuryHandlerUpdated"): EventFragment;
}
export interface TreasuryHandlerUpdatedEventObject {
    _handler: string;
}
export type TreasuryHandlerUpdatedEvent = TypedEvent<[
    string
], TreasuryHandlerUpdatedEventObject>;
export type TreasuryHandlerUpdatedEventFilter = TypedEventFilter<TreasuryHandlerUpdatedEvent>;
export interface Treasury extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: TreasuryInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        getProposalNonce(overrides?: CallOverrides): Promise<[BigNumber]>;
        proposalNonce(overrides?: CallOverrides): Promise<[BigNumber]>;
        rescueTokens(tokenAddress: PromiseOrValue<string>, to: PromiseOrValue<string>, amountToRescue: PromiseOrValue<BigNumberish>, nonce: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        setHandler(newHandler: PromiseOrValue<string>, nonce: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
    };
    getProposalNonce(overrides?: CallOverrides): Promise<BigNumber>;
    proposalNonce(overrides?: CallOverrides): Promise<BigNumber>;
    rescueTokens(tokenAddress: PromiseOrValue<string>, to: PromiseOrValue<string>, amountToRescue: PromiseOrValue<BigNumberish>, nonce: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    setHandler(newHandler: PromiseOrValue<string>, nonce: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    callStatic: {
        getProposalNonce(overrides?: CallOverrides): Promise<BigNumber>;
        proposalNonce(overrides?: CallOverrides): Promise<BigNumber>;
        rescueTokens(tokenAddress: PromiseOrValue<string>, to: PromiseOrValue<string>, amountToRescue: PromiseOrValue<BigNumberish>, nonce: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        setHandler(newHandler: PromiseOrValue<string>, nonce: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
    };
    filters: {
        "TreasuryHandlerUpdated(address)"(_handler?: null): TreasuryHandlerUpdatedEventFilter;
        TreasuryHandlerUpdated(_handler?: null): TreasuryHandlerUpdatedEventFilter;
    };
    estimateGas: {
        getProposalNonce(overrides?: CallOverrides): Promise<BigNumber>;
        proposalNonce(overrides?: CallOverrides): Promise<BigNumber>;
        rescueTokens(tokenAddress: PromiseOrValue<string>, to: PromiseOrValue<string>, amountToRescue: PromiseOrValue<BigNumberish>, nonce: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        setHandler(newHandler: PromiseOrValue<string>, nonce: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
    };
    populateTransaction: {
        getProposalNonce(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        proposalNonce(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        rescueTokens(tokenAddress: PromiseOrValue<string>, to: PromiseOrValue<string>, amountToRescue: PromiseOrValue<BigNumberish>, nonce: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        setHandler(newHandler: PromiseOrValue<string>, nonce: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
    };
}
